<script>

import config from "../../config";
import Layout from "../../layouts/main";
import PageHeader from "../../components/page-header";
import VueGoogleAutocomplete from 'vue-google-autocomplete';
import { commonService, driverService } from '../../services';
import { set_axios_defaults } from '../../Helper/helper';
import { error_message } from "../../Helper/helper";
import { success_message } from '../../Helper/helper';
import DropzoneSingle from '../../components/widgets/dropzone-single';

import {
    required,
    email,
    minLength,
    sameAs,
    maxLength,
    minValue,
    maxValue,
    numeric,
    url,
    alphaNum
} from "vuelidate/lib/validators";


export default {
    components: { PageHeader, VueGoogleAutocomplete, DropzoneSingle},
    props: ['driver_data'],
    data() {
        return {
            title: 'DRIVER DETAILS',
            value: null,
            value1: null,
            config:config,
            vehicle_photo:'',
            vehicle_document:'',
            zones:[],
            document:[],
            vehicle_type: [
                'Car',
                'Van',
                'Cycle',
                'Bike',
                'MotorBike'
            ],
            driver: {
                firstname: "",
                lastname: "",
                email: "",
                contactno: "",
                alternate_contactno: "",
                frenchise_id: "",
                address: "",
                firstname_other_lang: "",
                lastname_other_lang: "",
                vehicle_type: "",
                vehicle_number: "",
                licence_number: "",
                driverDocument: [],
                profileimage: "",
                city: "",
                state: "",
                zip_code: "",
                country: "",
                latitude:"",
                longitude: "",
            },  
        };
    },
    validations: {
        driver: {
            firstname: {
                required
            },
            lastname: {
                required
            },
            email: {
                required,
                email
            },
            contactno: {
                required,
                numeric
            },
            frenchise_id: {
                required
            },
            address: {
                required
            }
        }
    },
    mounted(){
        //this.getDriverInfo();
        this.getFrenchise();
        this.$refs.address.focus();
    },
    methods: {
        getAddressData: function (addressData, placeResultData, id) {
            this.address = addressData;
            this.driver.address = placeResultData.formatted_address;
            this.driver.city = addressData.locality;
            this.driver.state = addressData.administrative_area_level_1;
            this.driver.country = addressData.country;
            this.driver.latitude = addressData.latitude;
            this.driver.longitude = addressData.longitude;
            this.driver.zip_code = addressData.postal_code;
        },
        getDriverInfo(){
            // driverService.getDriverInfo({driver_id: this.$route.params.driver_id})
            // .then(response => {
                
            // });
            this.driver = this.rest_data.driver;
            this.document = this.rest_data.driver.driverDocument;
        },
        getFrenchise(){
            driverService.getFrenchise()
            .then(response => {
                this.zones =  response.data.result;
            });
        },
        typeForm(e) {
            this.$v.$touch();
            if (this.$v.driver.$invalid) {
                return;
            }
            else{
                let token = localStorage.getItem('token');
                var vehicle_photo = $("#vehicle_photo").val();
                var vehicle_document = $("#vehicle_document").val();
                if(token){
                    axios.post(config.api_url+'updateDriverProfile', {
                        driver: this.driver,
                        vehicle_photo: vehicle_photo,
                        vehicle_document: vehicle_document,
                        })
                        .then(response => {
                        if(response.data.code === 200){
                            alert(response.data.message);
                            // this.$router.go(0);
                        }else{
                            alert(response.data.message);
                        }
                    });
                }
            } 
        },
    }
};
</script>

<template>
    <div> 
        <div class="row">
            <div class="col-12">
                <form action="#" @submit.prevent="typeForm">
                <!-- Driver Info Start -->
                <div class="card details-profile-main">
                    <div class="card-body">
                        <h4 class="card-title">{{ trans.get('__JSON__.Personal Information') }}</h4>
                        <p class="card-title-desc"></p>

                        <div class="row">
                            <div class="col-sm-6">
                                <div class="form-group" v-if="$auth.setting">
                                <label>{{ trans.trans('__JSON__.First Name Primary Language',{lang: $auth.langauges[0].name}) }}</label>
                                <input id="firstname" v-model="$v.driver.firstname.$model" type="text" class="form-control" :placeholder="trans.trans('__JSON__.First Name Primary Language',{lang: $auth.langauges[0].name})" name="firstname" :class="{ 'is-invalid':$v.driver.firstname.$error }" />
                                    <div v-if="$v.driver.firstname.$error" class="invalid-feedback">
                                    <span v-if="!$v.driver.firstname.required">{{ trans.get('__JSON__.Please enter first name') }}</span>
                                    </div>
                                </div>
                            </div>

                            <div class="col-sm-6 d-none" v-if="$auth.langauges[1].name === 'No Secondary Language'">
                            </div>
                            <div class="col-sm-6" v-else>
                                <div class="form-group">
                                    <label>{{ trans.trans('__JSON__.First Name Secondary Language',{lang: $auth.langauges[1].name}) }}</label>
                                    <input id="firstname_other_lang" name="firstname_other_lang" v-model="driver.firstname_other_lang" type="text" :placeholder="trans.trans('__JSON__.First Name Secondary Language',{lang: $auth.langauges[1].name})" class="form-control" />
                                </div>
                            </div>
              
                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.trans('__JSON__.Last Name Primary Language',{lang: $auth.langauges[0].name}) }}</label>
                                <input id="lastname" v-model="$v.driver.lastname.$model" type="text" class="form-control" :placeholder="trans.trans('__JSON__.Last Name Primary Language',{lang: $auth.langauges[0].name})" name="lastname" :class="{ 'is-invalid':$v.driver.lastname.$error }" />
                                    <div v-if="$v.driver.lastname.$error" class="invalid-feedback">
                                    <span v-if="!$v.driver.lastname.required">{{ trans.get('__JSON__.Please enter last name') }}</span>
                                    </div>
                                </div>
                            </div>
                        
                            <div class="col-sm-6 d-none" v-if="$auth.langauges[1].name === 'No Secondary Language'">
                            </div>
                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.trans('__JSON__.Last Name Secondary Language',{lang: $auth.langauges[1].name}) }}</label>
                                <input id="lastname_other_lang" name="lastname_other_lang" v-model="driver.lastname_other_lang" type="text" :placeholder="trans.trans('__JSON__.Last Name Secondary Language',{lang: $auth.langauges[1].name})" class="form-control" />
                                </div>
                            </div>

                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.get('__JSON__.E-Mail') }}</label>
                                    <input id="email" v-model="$v.driver.email.$model" type="email" name="email" class="form-control" :class="{ 'is-invalid':$v.driver.email.$error }" :placeholder="trans.get('__JSON__.Enter Email')" />
                                    <div v-if="$v.driver.email.$error" class="invalid-feedback">
                                        <span v-if="!$v.driver.email.required">{{ trans.get('__JSON__.Please enter email') }}</span>
                                        <span v-if="!$v.driver.email.email">{{ trans.get('__JSON__.This value should be a valid email') }}</span>
                                    </div>
                                </div>
                            </div>

                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.get('__JSON__.Primary Contact Number') }}</label>
                                    <input id="contactno" v-model="$v.driver.contactno.$model" type="number" name="contactno" class="form-control" :class="{ 'is-invalid':$v.driver.contactno.$error }" :placeholder="trans.get('__JSON__.Primary contact number')" maxlength="12" minlength="7" />
                                    <div v-if="$v.driver.contactno.$error" class="invalid-feedback">
                                        <span v-if="!$v.driver.contactno.required">{{ trans.get('__JSON__.Please enter contact number') }}</span>
                                        <span v-if="!$v.driver.contactno.numeric">{{ trans.get('__JSON__.This value should be a valid number') }}</span>
                                    </div>
                                </div>
                            </div>

                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.get('__JSON__.Alternate contact number') }}</label>
                                    <input id="alternate_contactno" v-model="driver.alternate_contactno" type="number" name="alternate_contactno" class="form-control" :placeholder="trans.get('__JSON__.Alternate contact number')" maxlength="12" minlength="7" />
                                </div>
                            </div>

                            <div class="col-sm-6">
                                <div class="form-group">
                                <label class="control-label">{{ trans.get('__JSON__.Delivery Zone') }}</label>
                                <select class="custom-select" v-model="$v.driver.frenchise_id.$model" id="frenchise_id" name="frenchise_id"> 
                                    <option value="">{{trans.get('__JSON__.Select Delivery Zone')}}</option>
                                    <option v-for="zone in zones" :value="zone.user_id" :key="zone.user_id">{{zone.last_name}}</option>
                                </select>
                                <div v-if="$v.driver.frenchise_id.$error" class="invalid-feedback">
                                    <span v-if="!$v.driver.frenchise_id.required">{{ trans.get('__JSON__.Please enter select franchise') }}</span>
                                    </div>
                                </div>
                            </div>
                        
                            <div class="col-sm-6">
                                <div class="form-group">
                                    <label class="control-label">{{ trans.get('__JSON__.Full address') }}</label>
                                    <vue-google-autocomplete  
                                        ref="address"
                                        id="addres"
                                        name="address"
                                        type="text"
                                        class="form-control"
                                        placeholder="Please type your address"
                                        v-model="$v.driver.address.$model"
                                        v-on:placechanged="getAddressData"   
                                        :class="{'is-invalid':$v.driver.address.$error}"
                                    >
                                    </vue-google-autocomplete>
                                    <div v-if="$v.driver.address.$error" class="invalid-feedback">
                                        <span v-if="!$v.driver.address.required">{{ trans.get('__JSON__.Please enter address') }}</span>
                                    </div>
                                </div>
                            </div>
                            <div class="col-sm-4">
                                <div class="form-group">
                                <label class="control-label">{{ trans.get('__JSON__.Profile Image') }}</label>
                                    <dropzone-single v-model="$v.driver.profileimage" id="profile_image" acceptedFiles=".jpeg,.jpg,.png" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Driver Info End -->

                <!-- Vechile Info Section Start -->
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title">{{ trans.get('__JSON__.Vehicle Information') }}</h4>
                        <p class="card-title-desc"></p>
                        <div class="row">
                            <div class="col-sm-6">
                                <div class="form-group">
                                <label class="control-label">{{ trans.get('__JSON__.Vehicle Type') }}</label> 
                                <select class="custom-select" v-bind:value="driver.vehicle_type" v-model="driver.vehicle_type"  id="vehicle_type" name="vehicle_type"> 
                                    <option value="">{{trans.get('__JSON__.Select Vehicle Type')}}</option>
                                    <option value="Car">Car</option>
                                    <option value="Van">Van</option>
                                    <option value="Cycle">Cycle</option>
                                    <option value="Bike">Bike</option>
                                    <option value="Motorbike">Motorbike</option>
                                </select>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{trans.get('__JSON__.Vehicle Number')}}</label>
                                <input id="vehicle_number" type="text" class="form-control" v-model="driver.vehicle_number" :placeholder="trans.get('__JSON__.Vehicle Number')" name="vehicle_number"/>
                                </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.get('__JSON__.Licence Number') }}</label>
                                <input id="licence_number"  type="text" class="form-control" v-model="driver.licence_number" :placeholder="trans.get('__JSON__.Licence Number')" name="licence_number"/>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.get('__JSON__.National Identity Document') }}</label>
                                
                                <div id="driDropZone" class="fallback dropzone drop" enctype="multipart/form-data">
                                    <input type="file" name="productImage"  class="productimageMulti" id="productImage" style="display: none;">
                                    <input type="hidden" name="document_type" value="vehicle_photo">
                                    <div id="ImageGallery" v-for="doc in document" :key="doc.document_id">
                                        <div class="profile-picImg GalleryBox" id="GalleryBoxProfole_1504516327_68" v-if="doc.document_type == 'vehicle_photo' || doc.document_type == 'identity' || doc.document_type == 'agreement' || doc.document_type == 'document'">
                                        <img class="vendor-img avatar-xs proImag"  :src="config.driver_document+doc.document_name" @error="$event.target.src=config.no_image">
                                        <input type="hidden" id="vehicle_photo" name="vehicle_photo" v-bind:value="doc.document_name">  
                                        </div>
                                    </div>
                                    <input type="hidden" id="vehicle_photo" name="vehicle_photo" value="">
                                </div>
                                </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="form-group">
                                <label>{{ trans.get('__JSON__.Delivery Boy Licence Documents') }}</label>
                                <div id="drDropZone" class="fallback dropzone drop" enctype="multipart/form-data">
                                    <input type="file" name="productImage"  class="productimageMulti" id="productImage" style="display: none;">
                                    <input type="hidden" name="type" value="vehicle_document">
                                    <div id="ImageGallery" v-for="doc in document" :key="doc.document_id">
                                        <div class="profile-picImg GalleryBox" id="GalleryBoxProfole_1504516327_68" v-if="doc.document_type == 'vehicle_document' || doc.document_type == 'licence'">
                                        <img class="vendor-img avatar-xs proImag" :src="config.driver_document+doc.document_name" @error="$event.target.src=config.no_image">
                                        <input type="hidden" id="vehicle_document" name="vehicle_document" v-bind:value="doc.document_name">
                                        </div>
                                    </div>
                                    <input type="hidden" id="vehicle_document" name="vehicle_document" value="">
                                </div>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-6">
                                <button type="submit" v-if="$auth.hasPermission(config.permissions.driver_write)" class="btn btn-primary mr-1 mt-3">Update Driver</button>
                                <router-link :to="{name: 'driver-list'}" type="submit" class="btn btn-secondary mt-3">Cancel</router-link>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Vechile Info Section End -->
                </form>
            </div>
        </div>
      <!-- end row -->
    </div>
</template>